> ## Documentation Index
> Fetch the complete documentation index at: https://developer.fabric.inc/llms.txt
> Use this file to discover all available pages before exploring further.

# Search for customer's addresses

> With this endpoint, you can search for customer's addresses based on the specified filter conditions. In addition, you can tailor the search results by including or excluding the deleted addresses and the default addresses.<br />**Note**:A customer can have a default address for both billing and shipping.



## OpenAPI

````yaml customers.openapi post /customers/{customerId}/customer-address/search
openapi: 3.0.0
info:
  title: Customers
  description: >-
    The fabric **Customers** API is used to create and manage details of
    storefront customers, also referred to as shoppers. The `Customers` or
    `Customer Address` APIs provide features for store admins to manage their
    customers' details and addresses. The `Customer Self' API provide features
    for customers or shoppers to independently manage their own details.
  version: 3.0.0
  x-audience: external-public
  contact:
    name: fabric Support
    email: support@fabric.inc
  license:
    name: fabric API License
    url: https://fabric.inc/api-license
  termsOfService: https://fabric.inc/terms-of-use
servers:
  - url: https://api.fabric.inc/v3
    description: Production
security:
  - bearerAuth: []
tags:
  - name: Customer Profile
    description: >-
      These endpoints provide the features for store admins to create and manage
      customers' details.
  - name: Customer Address
    description: >-
      These endpoints provide the features for store admins to create and manage
      customers' addresses.
  - name: Customer Self
    description: >-
      These endpoints provide the feature for customers or shoppers to
      independently manage their details in the storefront.
paths:
  /customers/{customerId}/customer-address/search:
    parameters:
      - $ref: '#/components/parameters/xFabricTenantId'
      - $ref: '#/components/parameters/xFabricRequestId'
      - $ref: '#/components/parameters/customerIdPathParam'
    post:
      tags:
        - Customer Address
      summary: Search for customer's addresses
      description: >-
        With this endpoint, you can search for customer's addresses based on the
        specified filter conditions. In addition, you can tailor the search
        results by including or excluding the deleted addresses and the default
        addresses.<br />**Note**:A customer can have a default address for both
        billing and shipping.
      operationId: searchCustomerAddress
      requestBody:
        description: A sample request to search for the customer's addresses.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/customerAddressSearchRequest'
        required: true
      responses:
        '200':
          description: OK
          headers:
            x-fabric-request-id:
              $ref: dae96e30-e72e-4091-be69-ce7f63e78aa2
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/listCustomerAddressResponse'
        '400':
          $ref: '#/components/responses/searchBadRequest'
        '403':
          $ref: '#/components/responses/forbidden'
        '500':
          $ref: '#/components/responses/internalServerError'
components:
  parameters:
    xFabricTenantId:
      name: x-fabric-tenant-id
      in: header
      description: >-
        A header used by fabric to identify the tenant making the request. You
        must include tenant id in the authentication header for an API request
        to access any of fabric’s endpoints. You can retrieve the tenant id ,
        which is also called account id, from
        [Copilot](/v3/platform/settings/account-details/getting-the-account-id).
        This header is required.
      schema:
        type: string
        example: 517fa9dfd42d8b00g1o3k312
    xFabricRequestId:
      name: x-fabric-request-id
      in: header
      description: A UUID of the request.
      schema:
        type: string
      example: 263e731c-45c8-11ed-b878-0242ac120002
      required: false
    customerIdPathParam:
      in: path
      name: customerId
      description: >-
        A 24-character system-generated ID of the customer. This is returned in
        the response of the `POST /customers` endpoint.
      required: true
      style: simple
      schema:
        type: string
        example: 61a558b1b155125f02be7fb1
  schemas:
    customerAddressSearchRequest:
      type: object
      description: The criteria to search for customer's addresses.
      required:
        - match
      properties:
        sort:
          type: string
          description: >-
            The criteria to sort results, where `-` indicates a descending order
            and `+` indicates an ascending order. You can sort the following
            fields - `createdAt`, `updatedAt`, `type`, and `country`.
          example: '-createdAt'
        match:
          description: match
          allOf:
            - $ref: '#/components/schemas/customerAddressMatch'
        offset:
          type: number
          description: >-
            The number of records to skip before returning records. For example,
            when offset is 20 and limit's 10, this endpoint returns records from
            21 to 30.
          default: 0
          example: 0
        limit:
          type: number
          description: The maximum number of records in a single page.
          example: 10
          default: 20
    listCustomerAddressResponse:
      description: The list of customer addresses for the customerId.
      type: object
      properties:
        query:
          $ref: '#/components/schemas/Query'
        data:
          description: addresses of the sent customer
          type: array
          items:
            $ref: '#/components/schemas/customerAddressResponse'
    customerAddressMatch:
      type: object
      description: The criteria to search for customer's address.
      properties:
        id:
          $ref: '#/components/schemas/searchId'
        type:
          $ref: '#/components/schemas/searchType'
        addressLine1:
          $ref: '#/components/schemas/searchAddressLine'
        city:
          $ref: '#/components/schemas/searchCity'
        region:
          $ref: '#/components/schemas/searchRegion'
        postalCode:
          $ref: '#/components/schemas/searchPostalCode'
        county:
          $ref: '#/components/schemas/searchCounty'
        country:
          $ref: '#/components/schemas/searchCountry'
        latitude:
          $ref: '#/components/schemas/searchLatitude'
        longitude:
          $ref: '#/components/schemas/searchLongitude'
        createdAt:
          $ref: '#/components/schemas/searchCreatedAt'
        updatedAt:
          $ref: '#/components/schemas/searchUpdatedAt'
        deletedAt:
          $ref: '#/components/schemas/searchDeletedAt'
        additionalAttributes:
          $ref: '#/components/schemas/searchAdditionalAttribute'
        isDeleted:
          $ref: '#/components/schemas/searchIsDeleted'
        isDefault:
          $ref: '#/components/schemas/searchIsDefault'
    Query:
      type: object
      description: The pagination criteria.
      properties:
        offset:
          type: number
          description: >-
            The number of records to skip before returning records. For example,
            when offset is 20 and limit's 10, you get records from 21 to 30.
            When they're not specified, you get up to 10 records.
          example: 0
        limit:
          type: number
          description: The maximum number of records per page.
          example: 20
        count:
          type: number
          description: The total number of records in the response.
          example: 100
    customerAddressResponse:
      required:
        - id
        - address
        - isDeleted
        - createdAt
        - updatedAt
      type: object
      properties:
        id:
          type: string
          description: A 24-character system-generated ID of the address.
          example: 61604a30fdfacd0009816e44
          uniqueItems: true
        address:
          $ref: '#/components/schemas/commonAddress'
        additionalAttributes:
          description: A placeholder for additional info, in key-value pairs.
          type: object
          example:
            landmark: Beach
        isDeleted:
          type: boolean
          description: >-
            A flag indicating whether the address is deleted. `true` indicates
            the address is deleted and `false` indicates otherwise.
          example: false
        isDefault:
          description: >-
            A flag indicating whether the address is the default one.`true`
            indicates the given address is the default address and `false`
            indicates otherwise.
          type: boolean
          example: false
        deletedAt:
          description: The time when the address was deleted, in UTC format.
          type: string
          format: date-time
          example: '2023-08-30T23:20:42.822Z'
          nullable: true
        createdAt:
          description: The time when the address was created, in UTC format.
          type: string
          format: date-time
          example: '2023-08-30T23:20:42.822Z'
        updatedAt:
          description: The time when the address was the last updated, in UTC format.
          type: string
          format: date-time
          example: '2023-08-30T23:20:42.822Z'
          nullable: true
    message:
      description: The response message.
      type: object
      properties:
        type:
          description: A machine-readable code.
          type: string
          example: SUCCESS
        message:
          description: A human-friendly message corresponding to the `type`.
          type: string
          example: Success message
      required:
        - type
        - message
    searchId:
      type: object
      description: A unique identifier of the search criteria.
      properties:
        op:
          type: string
          enum:
            - IN
            - EQUALS
          description: The type of search operation.
          example: IN
        value:
          type: string
          description: A 24-character system-generated ID of the given search criteria.
          example: 61df41892bf06d00092d0d8a
      required:
        - op
        - value
    searchType:
      type: object
      description: The criteria to search based on the type of address.
      properties:
        op:
          type: string
          description: >-
            The type of search operation. Multiple values, separated by commas,
            can be used for the IN and NOT_IN operations, while only a single
            value can be used for the EQUALS, CONTAINS, and NOT_EQUALS
            operations.
          enum:
            - IN
            - NOT_IN
            - EQUALS
            - CONTAINS
            - NOT_EQUALS
          example: IN
        value:
          type: string
          description: The type of address.
          enum:
            - BILLING
            - SHIPPING
          example: BILLING
      required:
        - op
        - value
    searchAddressLine:
      type: object
      description: >-
        The criteria to search by the first, second, or third line of the
        customer's address.
      properties:
        op:
          type: string
          description: >-
            The type of search operation. Multiple values, separated by commas,
            can be used for the IN and NOT_IN operations, while only a single
            value can be used for the EQUALS, CONTAINS, and NOT_EQUALS
            operations.
          enum:
            - IN
            - NOT_IN
            - EQUALS
            - CONTAINS
            - NOT_EQUALS
          example: IN
        value:
          type: string
          description: The first, second, or third line of the customer's address.
          example: 123 Main St.
      required:
        - op
        - value
    searchCity:
      type: object
      description: >-
        The criteria to search for customer's addresses based on the `city`
        given in the address.
      properties:
        op:
          type: string
          description: >-
            The type of search operation. Multiple values, separated by commas,
            can be used for the IN and NOT_IN operations, while only a single
            value can be used for the EQUALS, CONTAINS, and NOT_EQUALS
            operations. - IN - NOT_IN - EQUALS - CONTAINS - NOT_EQUALS
          example: IN
        value:
          type: string
          description: The city name.
          example: Seattle
      required:
        - op
        - value
    searchRegion:
      type: object
      description: >-
        The criteria to search for customer's addresses based on the `region`
        given in the address.
      properties:
        op:
          type: string
          description: >-
            The type of search operation. Multiple values, separated by commas,
            can be used for the IN and NOT_IN operations, while only a single
            value can be used for the EQUALS, CONTAINS, and NOT_EQUALS
            operations.
          enum:
            - IN
            - NOT_IN
            - EQUALS
            - CONTAINS
            - NOT_EQUALS
          example: IN
        value:
          type: string
          description: The region name.
          example: WA
      required:
        - op
        - value
    searchPostalCode:
      type: object
      description: >-
        The criteria to search for customer's addresses based on `postalCode`
        given in the address.
      properties:
        op:
          type: string
          description: >-
            The type of search operation. Multiple values, separated by commas,
            can be used for the IN and NOT_IN operations, while only a single
            value can be used for the EQUALS, CONTAINS, and NOT_EQUALS
            operations.
          enum:
            - IN
            - NOT_IN
            - EQUALS
            - CONTAINS
            - NOT_EQUALS
          example: IN
        value:
          description: The postal or ZIP code of the address.
          type: string
          example: 98121
      required:
        - op
        - value
    searchCounty:
      type: object
      description: >-
        The criteria to search for customer's address based on the `county`
        given in the address.
      properties:
        op:
          type: string
          description: >-
            The type of search operation. Multiple values, separated by commas,
            can be used for the IN and NOT_IN operations, while only a single
            value can be used for the EQUALS, CONTAINS, and NOT_EQUALS
            operations. - IN - NOT_IN - EQUALS - CONTAINS - NOT_EQUALS
          example: IN
        value:
          type: string
          description: The county name.
          example: King County
    searchCountry:
      type: object
      description: >-
        The criteria to search for the customer's address based on the `country`
        given in the address.
      properties:
        op:
          type: string
          description: >-
            The type of search operation. Multiple values, separated by commas,
            can be used for the IN and NOT_IN operations, while only a single
            value can be used for the EQUALS, CONTAINS, and NOT_EQUALS
            operations.
          enum:
            - IN
            - NOT_IN
            - EQUALS
            - CONTAINS
            - NOT_EQUALS
          example: IN
        value:
          type: string
          description: >-
            The country code, which can be a full name, ISO 3166-1 alpha-2, or
            an alpha-3 code.
          example: US
      required:
        - op
        - value
    searchLatitude:
      type: object
      description: >-
        The criteria to search for customer's address based on latitude or a
        range of latitudes given in the address.
      properties:
        op:
          type: string
          description: >-
            The type of search operation, such as equals, less than (LT),
            greater than (GT), less than or equal to (LTE), greater than or
            equal to (GTE), or within a specified range.
          enum:
            - EQUALS
            - LTE
            - GTE
            - GT
            - LT
            - RANGE
          example: LTE
        value:
          type: number
          description: >-
            The latitude value in decimal degrees format; negative is degrees
            West.
          format: double
          example: 47.6205
        startLatitude:
          type: number
          description: >-
            The starting value of the latitude range. This is used with the
            `endLatitude` property. The coordinates are provided in decimal
            degrees format, with negative values indicating locations to the
            west.
          format: double
          example: 47.6205
        endLatitude:
          type: number
          format: double
          description: >-
            The ending value of the latitude range. This is used with the
            `startLatitude` property. The coordinates are provided in decimal
            degrees format, with negative values indicating locations to the
            west.
          example: 47.6205
      example:
        op: LTE
        value: 47.6205
      required:
        - op
    searchLongitude:
      type: object
      description: >-
        The criteria to search for customer's address based on longitude or a
        range of longitude given in the address.
      properties:
        op:
          type: string
          description: >-
            The type of search operation, such as equals, less than (LT),
            greater than (GT), less than or equal to (LTE), greater than or
            equal to (GTE), or within a specified range.
          enum:
            - EQUALS
            - LTE
            - GTE
            - GT
            - LT
            - RANGE
          example: LTE
        value:
          type: number
          description: >-
            The longitude value in decimal degrees format; negative is degrees
            West.
          format: double
          example: -77.0364
        startLongitude:
          type: number
          description: >-
            The starting value of the longitude range. This is used with the
            `endLongitude` property and formatted to decimal degrees; negative
            is degrees West.
          format: double
          example: -77.0364
        endLongitude:
          type: number
          format: double
          description: >-
            The ending value of the longitude range. This is used with the
            `startLongitude` property and formatted to decimal degrees; negative
            is degrees West.
          example: -77.0364
      example:
        op: LTE
        value: -77.0364
      required:
        - op
    searchCreatedAt:
      type: object
      description: >-
        The criteria to search for customers or their addresses based on a
        specific creation date or within a creation date range.
      properties:
        op:
          type: string
          description: >-
            The type of search operation, such as equals, less than (LT),
            greater than (GT), less than or equal to (LTE), greater than or
            equal to (GTE), or within a specified range.
          enum:
            - EQUALS
            - LTE
            - GTE
            - GT
            - LT
            - RANGE
          example: LTE
        value:
          type: string
          description: The time of creation, in UTC format.
          example: '2023-08-30T23:20:42.822Z'
        startCreatedAt:
          type: string
          description: >-
            The starting value of the creation date range. This is used with the
            `endCreatedAt` property.
          example: '2023-08-30T23:20:42.822Z'
        endCreatedAt:
          type: string
          description: >-
            The ending value of the creation date range. This is used with the
            `startCreatedAt` property.
          example: '2023-08-31T23:20:42.822Z'
      example:
        op: LTE
        value: '2023-08-30T23:20:42.822Z'
      required:
        - op
    searchUpdatedAt:
      type: object
      description: >-
        The criteria to search for customers or their addresses based on a
        specific date or date range in which the record was updated.
      properties:
        op:
          type: string
          description: >-
            The type of search operation, such as equals, less than (LT),
            greater than (GT), less than or equal to (LTE), greater than or
            equal to (GTE), or within a specified range.
          enum:
            - EQUALS
            - LTE
            - GTE
            - GT
            - LT
            - RANGE
          example: LTE
        value:
          type: string
          description: The time of last update, in UTC format.
          example: '2023-08-30T23:20:42.822Z'
        startUpdatedAt:
          type: string
          description: >-
            The starting value of the `updatedAt` date range. This is used with
            the `endUpdatedAt` property.
          example: '2023-08-30T23:20:42.822Z'
        endUpdatedAt:
          type: string
          description: >-
            The ending value of the `updatedAt` date range. This is used with
            the `startUpdatedAt` property.
          example: '2023-08-31T23:20:42.822Z'
      example:
        op: LTE
        value: '2023-08-30T23:20:42.822Z'
      required:
        - op
    searchDeletedAt:
      type: object
      description: >-
        The criteria to search for customers or their addresses based on a
        specific deletion date or within a deletion date range.
      properties:
        op:
          type: string
          description: >-
            The type of search operation, such as equals, less than (LT),
            greater than (GT), less than or equal to (LTE), greater than or
            equal to (GTE), or within a specified range.
          enum:
            - EQUALS
            - LTE
            - GTE
            - GT
            - LT
            - RANGE
          example: LTE
        value:
          type: string
          description: The time of deletion, in UTC format.
          example: '2023-08-30T23:20:42.822Z'
        startDeletedAt:
          type: string
          description: >-
            The starting value of the `deletedAt` date range. This is used with
            the `endDeletedAt` property.
          example: '2023-08-30T23:20:42.822Z'
        endDeletedAt:
          type: string
          description: >-
            The ending value of the `deletedAt` date range. This is used with
            the `startDeletedAt` property.
          example: '2023-08-31T23:20:42.822Z'
      example:
        op: LTE
        value: '2023-08-30T23:20:42.822Z'
      required:
        - op
    searchAdditionalAttribute:
      type: object
      description: >-
        The criteria to search for customers or their addresses based on
        additional attributes.
      properties:
        key:
          type: string
          description: >-
            The key for the additional attribute. This should be the field name
            given in the `additionalAttributes` schema.
          example: gps
      anyOf:
        - $ref: '#/components/schemas/searchStringOperation'
        - $ref: '#/components/schemas/searchNumberOrDateOperation'
      required:
        - key
        - op
    searchIsDeleted:
      type: boolean
      description: >-
        A flag indicating whether the search results should include only deleted
        addresses. Set to `true` to include only deleted addresses and `false`
        to exclude deleted addresses.
      enum:
        - false
        - true
      example: false
    searchIsDefault:
      type: boolean
      description: >-
        A flag indicating whether the search results should include only default
        addresses. Set to 'true' to include only default addresses and 'false'
        to exclude default addresses.
      enum:
        - false
        - true
      example: true
    commonAddress:
      type: object
      description: The address details.
      required:
        - type
      properties:
        addressLine1:
          description: The first line of the address.
          type: string
          example: 123 Main St.
        addressLine2:
          description: The second line of the address.
          type: string
          example: Suite 100
        addressLine3:
          description: The third line of the address.
          type: string
          example: Seventh floor
        addressLine4:
          description: The fourth line of the address.
          type: string
          example: 'Attention: Pat E. Doe'
        city:
          description: The city name in the address.
          type: string
          example: Seattle
        region:
          description: The region or state name in the address.
          type: string
          example: WA
        postalCode:
          description: The postal or ZIP code of the address.
          type: string
          example: 98121
        county:
          description: The administrative division or county within a country or state.
          type: string
          example: King County
        country:
          description: >-
            The country code, which can be a full name, or an ISO 3166-1 alpha-2
            or alpha-3 code.
          type: string
          example: US
        type:
          description: The address type.
          type: string
          enum:
            - BILLING
            - SHIPPING
          example: BILLING
        latitude:
          description: >-
            The geographical `latitude` used with `longitude` to locate the
            exact address. The coordinates are provided in decimal degrees
            format, with negative values indicating locations to the west.
          type: number
          format: double
          example: 47.6205
        longitude:
          description: >-
            The geographical `longitude` used with `latitude` to locate the
            exact address. The coordinates are provided in decimal degrees
            format, with negative values indicating locations to the west.
          type: number
          format: double
          example: -122.3493
    searchStringOperation:
      type: object
      description: The criteria to search by a string value.
      properties:
        op:
          type: string
          description: >-
            The type of search operation. Multiple values, separated by commas,
            can be used for the IN and NOT_IN operations, while only a single
            value can be used for the EQUALS, CONTAINS, and NOT_EQUALS
            operations.
          enum:
            - IN
            - NOT_IN
            - EQUALS
            - CONTAINS
            - NOT_EQUALS
          example: IN
        value:
          type: string
          description: The value of the string.
          example: beach
    searchNumberOrDateOperation:
      type: object
      description: >-
        The criteria to search for records by number, date, range of numbers, or
        range of dates.
      properties:
        op:
          type: string
          description: >-
            The type of search operation, such as equals, less than (LT),
            greater than (GT), less than or equal to (LTE), greater than or
            equal to (GTE), or within a specified range.
          enum:
            - EQUALS
            - LTE
            - GTE
            - GT
            - LT
            - RANGE
          example: LTE
        value:
          type: string
          description: The value of the number or the date.
          example: '2023-08-30T23:20:42.822Z'
        fromValue:
          type: string
          description: >-
            The starting value of the number or date range. This is used with
            the `toValue` property.
          example: '2023-08-30T23:20:42.822Z'
        toValue:
          type: string
          description: >-
            The ending value of the number or date range. This is used with the
            `fromValue` property.
          example: '2023-08-31T23:20:42.822Z'
      example:
        op: LTE
        value: '2023-08-30T23:20:42.822Z'
  responses:
    searchBadRequest:
      description: Bad request
      headers:
        x-fabric-request-id:
          $ref: dae96e30-e72e-4091-be69-ce7f63e78aa2
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/message'
          examples:
            invalidAccountProvided:
              value:
                type: INVALID_ACCOUNT_PROVIDED
                message: Invalid account provided for the request.
            invalidSearchOperation:
              value:
                type: INVALID_SEARCH_OPERATION
    forbidden:
      description: Forbidden Request
      headers:
        x-fabric-request-id:
          description: Unique request ID
          schema:
            type: string
            example: 263e731c-45c8-11ed-b878-0242ac120002
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/message'
          example:
            type: REQUEST_DENIED
            message: Forbidden
    internalServerError:
      description: The request is received but an internal error occurred
      headers:
        x-fabric-request-id:
          $ref: dae96e30-e72e-4091-be69-ce7f63e78aa2
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/message'
          example:
            type: INTERNAL_SERVER_ERROR
            message: Internal server error
  securitySchemes:
    bearerAuth:
      description: The access token.
      type: http
      scheme: bearer
      bearerFormat: JWT

````